#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=icon-ssh.ico
#AutoIt3Wrapper_Outfile_x64=SSH-Toolkit.exe
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <GUIConstantsEx.au3>
#include <ColorConstants.au3>

#comments-start
© 2018 Dennis Henß (dennis-henss.de)
v0.4
---
Todo:
- Netzlaufwerke verbinden
- NAS Restart
- Vertikale Linie zur Trennung der Raspis von den NAS
- Sicherheitsabfrage Shutdown Kodi
#comments-end
$version = "v0.4"

$window = GUICreate("AutoIt-SSH",600,400)

;Labels erstellen
GUICtrlCreateLabel("DiskStation DS214",30,20)
GUICtrlCreateLabel("DiskStation DS218j",150,20)
GUICtrlCreateLabel("Kodi",270,20)
GUICtrlCreateLabel("OpenVPN",390,20)
GUICtrlCreateLabel($version,570,20)

;Horizontale Linien erstellen
	GUICtrlCreateLabel("",30,40,100,1)
	GUICtrlSetBkColor(-1,0xA0A0A0)

	GUICtrlCreateLabel("",150,40,100,1)
	GUICtrlSetBkColor(-1,0xA0A0A0)

	GUICtrlCreateLabel("",270,40,100,1)
	GUICtrlSetBkColor(-1,0xA0A0A0)

	GUICtrlCreateLabel("",390,40,100,1)
	GUICtrlSetBkColor(-1,0xA0A0A0)

;Fenster aktivieren/anzeigen
GUISetState(@SW_SHOW,$window)

;Buttons für DS214 erstellen
$ds214start = GUICtrlCreateButton("Start",30,60,100)
GUICtrlSetBkColor($ds214start,$COLOR_GREEN)
$ds214shutdown = GUICtrlCreateButton("Shutdown",30,100,100)
GUICtrlSetBkColor($ds214shutdown,$COLOR_RED)

;Buttons für DS218j erstellen
$ds218start = GUICtrlCreateButton("Start",150,60,100)
GUICtrlSetBkColor($ds218start,$COLOR_GREEN)
$ds218shutdown = GUICtrlCreateButton("Shutdown",150,100,100)
GUICtrlSetBkColor($ds218shutdown,$COLOR_RED)
$ds218_mnt_pics = GUICtrlCreateButton("Mount Bilder",150,140,100)
$ds218_unmnt_pics = GUICtrlCreateButton("Unmount Bilder",150,180,100)
$ds218_mnt_backups = GUICtrlCreateButton("Mount Backups",150,220,100)
$ds218_unmnt_backups = GUICtrlCreateButton("Unmount Backups",150,260,100)

;Buttons für Kodi erstellen
$kodi_restart = GUICtrlCreateButton("Restart",270,60,100)
GUICtrlSetBkColor($kodi_restart,$COLOR_MONEYGREEN)
$kodi_shutdown = GUICtrlCreateButton("Shutdown",270,100,100)
GUICtrlSetBkColor($kodi_shutdown,$COLOR_RED)

;Buttons für OpenVPN Raspi erstellen
$openvpn_restart = GUICtrlCreateButton("Restart",390,60,100)
GUICtrlSetBkColor($openvpn_restart,$COLOR_MONEYGREEN)
$openvpn_shutdown = GUICtrlCreateButton("Shutdown",390,100,100)
GUICtrlSetBkColor($openvpn_shutdown,$COLOR_RED)

;Button für Start DesktopDH erstellen
$desktopdhstart = GUICtrlCreateButton("Start DesktopDH",30,360,100)

;Schließen-Button erstellen
$buttonclose = GUICtrlCreateButton("Beenden",470,360,100)

;---
;Schleife, um auf Eingaben zu warten. Darf nicht gelöscht werden.
While 1
	$msg = GUIGetMsg()

;Eingaben. Bei Klick auf die Buttons wird der jeweilige Befehl und dadurch die entsprechende Funktion unten ausgeführt.
Select
	Case $msg = $ds214start
		ds214_start()
	Case $msg = $ds214shutdown
		ds214_shutdown()
	Case $msg = $ds218start
		ds218_start()
	Case $msg = $ds218shutdown
		ds218_shutdown()
	Case $msg = $ds218_mnt_pics
		ds218_mnt_pics()
	Case $msg = $ds218_unmnt_pics
		ds218_unmnt_pics()
	Case $msg = $ds218_mnt_backups
		ds218_mnt_backups()
	Case $msg = $ds218_unmnt_backups
		ds218_unmnt_backups()
	Case $msg = $kodi_restart
		kodi_restart()
	Case $msg = $kodi_shutdown
		kodi_shutdown()
	Case $msg = $openvpn_restart
		; Da ich den OpenVPN Raspi nicht versehentlich neustarten will, hier eine Sicherheitsabfrage
		If MsgBox(4100,"Confirmation prompt","Are you sure you want to restart the OpenVPN-Server?") = 6 Then
			openvpn_restart()
		EndIf
	Case $msg = $openvpn_shutdown
		; Da ich den OpenVPN Raspi nicht versehentlich herunterfahren will, hier eine Sicherheitsabfrage
		If MsgBox(4100,"Confirmation prompt","Are you sure you want to SHUTDOWN the OpenVPN-Server?") = 6 Then
			openvpn_shutdown()
		EndIf
	Case $msg = $desktopdhstart
		desktopdh_start()
	Case $msg = $buttonclose OR $msg = $GUI_EVENT_CLOSE
		close()
EndSelect
WEnd

#comments-start
Funktionen für die Buttons

Netzwerkgeräte:
Raspberry Pi mit OpenVPN und WOL-Server: 192.168.1.2
Raspberry Pi mit Kodi: 192.168.1.200
DiskStation214: 192.168.1.214
DiskStation218j: 192.168.1.218

#Comments-end

;Funktionen für DS214
Func ds214_start()
	Run("plink -ssh pi@192.168.1.2 -pw RootPW_Raspi wakeonlan 00:11:22:33:44:55","",@SW_HIDE)
EndFunc


Func ds214_shutdown()
	Run("plink -ssh root@192.168.1.214 -pw RootPW_DS sudo poweroff","",@SW_HIDE)
EndFunc
;---------------------

;Funktionen für DS218j
Func ds218_start()
	Run("plink -ssh pi@192.168.1.2 -pw RootPW_Raspi wakeonlan 00:11:22:33:44:55","",@SW_HIDE)
EndFunc

Func ds218_shutdown()
	Run("plink -ssh root@192.168.1.218 -pw RootPW_DS sudo poweroff","",@SW_HIDE)
EndFunc

Func ds218_mnt_pics()
	$pw_pics = InputBox("Kennwort eingeben",'Bitte geben Sie das Kennwort für den Share "Bilder "ein.',"","*")
	Run('plink -ssh root@192.168.1.218 -pw RootPW_DS /usr/syno/sbin/synoshare --enc_mount "Bilder" ' & $pw_pics,"",@SW_HIDE)
	; Evtl. noch Netzlaufwerk herstellen
EndFunc

Func ds218_unmnt_pics()
	Run('plink -ssh root@192.168.1.218 -pw RootPW_DS /usr/syno/sbin/synoshare --enc_unmount "Bilder"',"",@SW_HIDE)
EndFunc

Func ds218_mnt_backups()
	$pw_backups = InputBox("Kennwort eingeben",'Bitte geben Sie das Kennwort für den Share "Backups "ein.',"","*")
	Run('plink -ssh root@192.168.1.218 -pw RootPW_DS /usr/syno/sbin/synoshare --enc_mount "Backups" ' & $pw_backups,"",@SW_HIDE)
	; Evtl. noch Netzlaufwerk herstellen
EndFunc

Func ds218_unmnt_backups()
	Run('plink -ssh root@192.168.1.218 -pw RootPW_DS /usr/syno/sbin/synoshare --enc_unmount "Backups"',"",@SW_HIDE)
EndFunc
;---------------------

;Funktionen für Kodi
Func kodi_restart()
	Run('plink -ssh root@192.168.1.200 -pw libreelec shutdown -r now',"",@SW_HIDE)
EndFunc

Func kodi_shutdown()
	Run('plink -ssh root@192.168.1.200 -pw libreelec shutdown -h now',"",@SW_HIDE)
EndFunc
;---------------------

;Funktionen für OpenVPN
Func openvpn_restart()
	Run('plink -ssh pi@192.168.1.2 -pw RootPW_Raspi sudo shutdown -r now',"",@SW_HIDE)
EndFunc

Func openvpn_shutdown()
	Run('plink -ssh pi@192.168.1.2 -pw RootPW_Raspi sudo shutdown -h now',"",@SW_HIDE)
EndFunc
;---------------------

;WOL Desktop-PC
Func desktopdh_start()
	Run("plink -ssh pi@192.168.1.2 -pw RootPW_Raspi wakeonlan 00:11:22:33:44:55","",@SW_HIDE)
EndFunc
;---------------------

Func close()
	Exit
EndFunc